#include <SPI.h>
#include <SD.h>


File myFile;

uint16_t Ptr[16];
uint16_t iSeq;
int a;

void setup() {
  uint16_t SSCTime;
  char szName[15]={'\0'};
  uint8_t btStep;
uint8_t stepnumber;
  uint16_t Pin[10];
 ;
 
  // Open serial communications and wait for port to open:
  Serial.begin(115200);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }


  if (!SD.begin(10)) {
    Serial.println("failed!");
    while (1);
  }
  Serial.println("Reading...");

  myFile = SD.open("arduino.bin");
  if (myFile) {
    
  iSeq=(myFile.read() ) | myFile.read()<<8; 
  
  for (int j=1;j<=iSeq;j++){
      myFile.readBytes(szName, 15); 
      btStep=myFile.read();
      // 90 01
      SSCTime =   (myFile.read() ) | myFile.read()<<8; 
      Ptr[j-1] =   (myFile.read() ) | myFile.read()<<8; 

    for (int i=1;i<btStep+1;i++){
      //stepnumber= myFile.read();
      //Serial.print("\n");
      //Serial.print(stepnumber);
      //Serial.print(":");
      for (int k=0;k<10;k++){
                  Pin[k]= (myFile.read() ) | myFile.read()<<8; 
          }
      }

  }
    myFile.close();
    Serial.println("Done...");
  }
  
}



void playSeq(int n){
  char szName[15]={'\0'};
  byte iStep;
  int SSCTime;
  int P;
  uint16_t Pin[10];
  
  myFile = SD.open("arduino.bin");
  if (myFile) {
  myFile.seek(Ptr[n-1]);
  
  myFile.readBytes(szName, 15); 
  iStep=myFile.read();
  SSCTime =   (myFile.read() ) | myFile.read()<<8; 
  P =   (myFile.read() ) | myFile.read()<<8; 

    Serial.print("Name:");
    Serial.print(szName);
    Serial.print("\n");
     Serial.print("Step:");
    Serial.print(iStep);
    Serial.print("\n");
/*    Serial.print("SSCTIME:");
    Serial.print(SSCTime);
    Serial.print("\n");
   Serial.print("Ptr:");
    Serial.print(P);
    Serial.println();
*/
  for (int i=1;i<iStep+1;i++){  
     for (int k=0;k<10;k++){
                  Pin[k]= (myFile.read() ) | myFile.read()<<8; 
                  Serial.print(Pin[k]);
                  if (k<9){Serial.print(",");}
                  else{Serial.println();}
                  
          }
      } 
  }
  myFile.close();
  a=0;
}

void loop() {
  // nothing happens after setup
int v;
  if (Serial.available() > 0)  {
      
      v =Serial.parseInt();// uint16_t(Serial.read()-48);

      if (v>0 && v<=iSeq){a=v;}

  }
  if (a>0)
    playSeq(a);

  delay(20);
}
